searchData={"content_type":"text/markdown","items":[{"doc":"Module","ref":"Fluent.html","title":"Fluent","type":"module"},{"doc":"Gets the locale for the current process and the given assembly.\nThis function returns the value of the locale for the current process and the\ngiven `assembly`. If there is no locale for the current process and the given\nassembly, then either the global Fluent locale (if set), or the default locale\nfor the given assembly, or the global default locale is returned. See the\n\"Locale\" section in the module documentation for more information.","ref":"Fluent.html#get_locale/1","title":"Fluent.get_locale/1","type":"function"},{"doc":"Fluent.get_locale(MyApp.Fluent)\n    #=> \"en\"","ref":"Fluent.html#get_locale/1-examples","title":"Examples - Fluent.get_locale/1","type":"function"},{"doc":"Returns all the locales for which FTL files exist for the given `assembly`.\nIf the translations directory for the given assembly doesn't exist, then an\nempty list is returned.","ref":"Fluent.html#known_locales/1","title":"Fluent.known_locales/1","type":"function"},{"doc":"With the following assembly:\n    defmodule MyApp.Fluent do\n      use Fluent.Assembly, otp_app: :my_app\n    end\nand the following translations directory:\n    my_app/priv/fluent\n    ├─ en\n    ├─ it\n    └─ pt_BR\nthen:\n    Fluent.known_locales(MyApp.Fluent)\n    #=> [\"en\", \"it\", \"pt_BR\"]","ref":"Fluent.html#known_locales/1-examples","title":"Examples - Fluent.known_locales/1","type":"function"},{"doc":"","ref":"Fluent.html#put_locale/1","title":"Fluent.put_locale/1","type":"function"},{"doc":"Sets the locale for the current process and the given `assembly`.\nThe locale is stored in the process dictionary. `locale` must be a string; if\nit's not, an `ArgumentError` exception is raised.","ref":"Fluent.html#put_locale/2","title":"Fluent.put_locale/2","type":"function"},{"doc":"Fluent.put_locale(MyApp.Fluent, \"pt_BR\")\n    #=> nil\n    Fluent.get_locale(MyApp.Fluent)\n    #=> \"pt_BR\"","ref":"Fluent.html#put_locale/2-examples","title":"Examples - Fluent.put_locale/2","type":"function"},{"doc":"Runs `fun` with the global Fluent locale set to `locale`.\nThis function just sets the global Fluent locale to `locale` before running\n`fun` and sets it back to its previous value afterwards. Note that\n`put_locale/2` is used to set the locale, which is thus set only for the\ncurrent process (keep this in mind if you plan on spawning processes inside\n`fun`).\nThe value returned by this function is the return value of `fun`.","ref":"Fluent.html#with_locale/2","title":"Fluent.with_locale/2","type":"function"},{"doc":"Fluent.put_locale(\"fr\")\n    MyApp.Fluent.ftl(\"Hello world\")\n    #=> \"Bonjour monde\"\n    Fluent.Assembly.with_locale \"it\", fn ->\n      MyApp.Fluent.ftl(\"Hello world\")\n    end\n    #=> \"Ciao mondo\"\n    MyApp.Fluent.ftl(\"Hello world\")\n    #=> \"Bonjour monde\"","ref":"Fluent.html#with_locale/2-examples","title":"Examples - Fluent.with_locale/2","type":"function"},{"doc":"Runs `fun` with the `Fluent.Assembly` locale set to `locale` for the given `assembly`.\nThis function just sets the Fluent.Assembly locale for `assembly` to `locale` before\nrunning `fun` and sets it back to its previous value afterwards. Note that\n`put_locale/2` is used to set the locale, which is thus set only for the\ncurrent process (keep this in mind if you plan on spawning processes inside\n`fun`).\nThe value returned by this function is the return value of `fun`.","ref":"Fluent.html#with_locale/3","title":"Fluent.with_locale/3","type":"function"},{"doc":"Fluent.put_locale(MyApp.Fluent, \"fr\")\n    MyApp.Fluent.ftl(\"Hello world\")\n    #=> \"Bonjour monde\"\n    Fluent.with_locale MyApp.Fluent, \"it\", fn ->\n      MyApp.Fluent.ftl(\"Hello world\")\n    end\n    #=> \"Ciao mondo\"\n    MyApp.Fluent.ftl(\"Hello world\")\n    #=> \"Bonjour monde\"","ref":"Fluent.html#with_locale/3-examples","title":"Examples - Fluent.with_locale/3","type":"function"},{"doc":"Name for Fluent's assembly. Should be valid module, that *uses* `Fluent.Assembly`","ref":"Fluent.html#t:assembly/0","title":"Fluent.assembly/0","type":"type"},{"doc":"Native container, that is firstly identified and then used for translations","ref":"Fluent.html#t:bundle/0","title":"Fluent.bundle/0","type":"type"},{"doc":"Represents locale. Basically it's a string, that has valid locale identifier","ref":"Fluent.html#t:locale/0","title":"Fluent.locale/0","type":"type"},{"doc":"Module","ref":"Fluent.Assembly.html","title":"Fluent.Assembly","type":"module"},{"doc":"Doc for using macro\n\nopts:\n\n* otp_app: \"libfluen\"\n* priv: \"priv/fluent\"\n* default_locale: \"en-US\"\n* use_isolating: false - default is true","ref":"Fluent.Assembly.html#__using__/1","title":"Fluent.Assembly.__using__/1","type":"macro"},{"doc":"","ref":"Fluent.Assembly.html#t:t/0","title":"Fluent.Assembly.t/0","type":"type"},{"doc":"Module","ref":"Fluent.Assembly.Source.html","title":"Fluent.Assembly.Source","type":"module"},{"doc":"Returns absolute path to directory, which contains all FTL data for `assembly`.","ref":"Fluent.Assembly.Source.html#assembly_dir/1","title":"Fluent.Assembly.Source.assembly_dir/1","type":"function"},{"doc":"iex> assembly_dir(MyApp.Fluent)\n    \"/path/to/ftl/files/\"","ref":"Fluent.Assembly.Source.html#assembly_dir/1-examples","title":"Examples: - Fluent.Assembly.Source.assembly_dir/1","type":"function"},{"doc":"Returns absolute pathes to all FTL files for given `assembly` and it's `locale`.","ref":"Fluent.Assembly.Source.html#ftl_files_pathes/2","title":"Fluent.Assembly.Source.ftl_files_pathes/2","type":"function"},{"doc":"iex> ftl_files_pathes(MyApp.Fluent, \"en\")\n    [\"/path/to/ftl/1.ftl\", \"/path/to/ftl/2.frl\", ... \"/path/to/ftl/last.ftl\"]","ref":"Fluent.Assembly.Source.html#ftl_files_pathes/2-examples","title":"Examples: - Fluent.Assembly.Source.ftl_files_pathes/2","type":"function"},{"doc":"Returns absolute path to directory, which contains all FTL data for `assembly` with given `locale`.","ref":"Fluent.Assembly.Source.html#locale_dir/2","title":"Fluent.Assembly.Source.locale_dir/2","type":"function"},{"doc":"iex> assembly_dir(MyApp.Fluent, \"en-US\")\n    \"/path/to/ftl/files/en-US\"","ref":"Fluent.Assembly.Source.html#locale_dir/2-examples","title":"Examples: - Fluent.Assembly.Source.locale_dir/2","type":"function"},{"doc":"Returns list of all available locales for given `assembly`","ref":"Fluent.Assembly.Source.html#locales/1","title":"Fluent.Assembly.Source.locales/1","type":"function"},{"doc":"iex> locales(MyApp.Fluent)\n    [\"en\", \"fr\", \"ru\"]","ref":"Fluent.Assembly.Source.html#locales/1-examples","title":"Examples: - Fluent.Assembly.Source.locales/1","type":"function"},{"doc":"Module","ref":"Fluent.Native.html","title":"Fluent.Native","type":"module"},{"doc":"","ref":"Fluent.Native.html#assert_locale/1","title":"Fluent.Native.assert_locale/1","type":"function"},{"doc":"Performs localization for given `message` with given `bundle`.\n\nReturns `ok` tuple if message is succeeded\nPotentially can crash in the `bundle` that is given not match.","ref":"Fluent.Native.html#format_pattern/3","title":"Fluent.Native.format_pattern/3","type":"function"},{"doc":"Initializes Fluent native bundle for given `locale`, and returns reference to it on succeded initialization.\n\nAvailable options:\n\n* `use_isolating` - if set to **false**, removes isolation for messages. Can be used in specific environments to prevent unnesessary identation.\n  Must be set to **true** in for right-to-left locale usages.","ref":"Fluent.Native.html#init/2","title":"Fluent.Native.init/2","type":"function"},{"doc":"iex> init(\"en\")\n    {:ok, #Reference }","ref":"Fluent.Native.html#init/2-examples","title":"Examples: - Fluent.Native.init/2","type":"function"},{"doc":"Adds new FTL `resource` for existing `bundle`.\n\nResource **mast be** valid FTL source. The function can returns `:ok` if `resource` is valid,\nand does not return `bundle` reference again, becuse data under the reference is mutable.","ref":"Fluent.Native.html#with_resource/2","title":"Fluent.Native.with_resource/2","type":"function"},{"doc":"iex> {:ok, bundle} = init(\"en\")\n    {:ok, #Reference }\n\n    iex> with_resource(bundle, \"key = Translation\")\n    :ok","ref":"Fluent.Native.html#with_resource/2-examples","title":"Examples: - Fluent.Native.with_resource/2","type":"function"},{"doc":"This module hande references to active bundles, that are using during runtimne\nof the program","ref":"Fluent.Store.html","title":"Fluent.Store","type":"module"},{"doc":"","ref":"Fluent.Store.html#format_pattern/4","title":"Fluent.Store.format_pattern/4","type":"function"},{"doc":"","ref":"Fluent.Store.html#get_store/1","title":"Fluent.Store.get_store/1","type":"function"},{"doc":"Example:\n\niex> Fluent.Store.initialize_bundle(MyApp.Fluent, \"en-US\")","ref":"Fluent.Store.html#initialize_locale/2","title":"Fluent.Store.initialize_locale/2","type":"function"},{"doc":"","ref":"Fluent.Store.html#initialize_store/1","title":"Fluent.Store.initialize_store/1","type":"function"},{"doc":"","ref":"Fluent.Store.html#known_locales/1","title":"Fluent.Store.known_locales/1","type":"function"},{"doc":"","ref":"Fluent.Store.html#t:t/0","title":"Fluent.Store.t/0","type":"type"},{"doc":"","ref":"Fluent.MessageNotFound.html","title":"Fluent.MessageNotFound","type":"exception"},{"doc":"# libfluent\n[![](https://img.shields.io/hexpm/dt/libfluent.svg?style=flat-square)](https://hex.pm/packages/libfluent)[![](https://img.shields.io/hexpm/v/libfluent.svg?style=flat-square)](https://hex.pm/packages/libfluent)[![](https://img.shields.io/hexpm/l/libfluent.svg?style=flat-square)](https://hex.pm/packages/libfluent)[![](https://img.shields.io/circleci/build/gh/Virviil/libfluent?style=flat-square)](https://circleci.com/gh/Virviil/libfluent)[![](https://img.shields.io/coveralls/github/Virviil/libfluent.svg?style=flat-square)](https://coveralls.io/github/Virviil/libfluent)[![](https://img.shields.io/github/last-commit/virviil/libfluent.svg?style=flat-square)](https://github.com/Virviil/libfluent/commits)[![](https://img.shields.io/maintenance/yes/2020.svg?style=flat-square)](https://github.com/Virviil/libfluent)\n\nModule provides [**Project Fluent**](https://projectfluent.org/) bindings and API to build \ninternationalized applications. API is trying to be as simmilar as possible to \nElixir's *default* internatrionalization library - [**Gettext**](https://hex.pm/packages/gettext)\n\nAt the same time, `Fluent.Native` module - as native binding - can be used to work with **Project Fluent**\nfrom any structure of choice. One can use it to define his own API, that is opposite to **Gettext** API\nas much as he wants.","ref":"readme.html","title":"libfluent","type":"extras"},{"doc":"To use **Fluent**, a module that calls `use Fluent.Assembly` has to be defined:\n\n```elixir\ndefmodule MyApp.Fluent do\n  use Fluent.Assembly, otp_app: :my_app\nend\n```\n\nThis automatically defines some funcitons in the `MyApp.Fluent` module, that can be used to translation:\n\n```elixir\nimport MyApp.Fluent\n\n# Simple translation\nftl(\"hello-world\")\n\n# Argument-based translation\nftl(\"hello-user\", userName: \"Alice\")\n\n# With different types\nftl(\"shared-photos\", userName: \"Alice\", userGender: \"female\", photoCount: 3)\n```","ref":"readme.html#using-fluent","title":"Using Fluent - libfluent","type":"extras"},{"doc":"Translations are stored inside **FTL** files, with `.ftl` extension. \nSyntax overview can be found [here](https://projectfluent.org/fluent/guide/)\n\n**FTL** files, containgin translations for an application must be stored in a directory (by default it's `priv/fluent`),\nthat has the following structure:\n\n```bash\n%FLUENT_TRANSLATIONS_DIRECTORY%\n└─ %LOCALE%\n   ├─ file_1.ftl\n   ├─ file_2.ftl\n   └─ file_3.ftl\n```\n\nHere, **%LOCALE%** is the locale of the translations (for example, `en_US`),\nand file_i.ftl are FTL files containing translations. All the files from single translation\nare loaded as the single scope, so name conflicts inside the files in one folder should be avoided.\n\nA concrete example of such a directory structure could look like this:\n\n```bash\npriv/gettext\n└─ en_US\n|  ├─ default.ftl\n|  └─ errors.ftl\n└─ it\n   ├─ default.ftl\n   └─ errors.ftl\n```\n\nBy default, **Fluent** expects translations to be stored under the `fluent` directory inside `priv` directory of an application. This behaviour can be changed by specifying a `:priv` option when using `Fluent.Assembly`:\n\n```elixir\n# Look for translations in my_app/priv/translations instead of\n# my_app/priv/gettext\nuse Fluent.Assembly, otp_app: :my_app, priv: \"translations\"\n```","ref":"readme.html#translations","title":"Translations - libfluent","type":"extras"},{"doc":"At runtime, all translation functions that do not explicitly take a locale as an argument read the locale from the assembly locale and then fallbacks to `libfluent`'s locale.\n\n`Fluent.put_locale/1` can be used to change the locale of all assemblies for the current Elixir process. That's the preferred mechanism for setting the locale at runtime. `Fluent.put_locale/2` can be used when you want to set the locale of one specific **Fluent** assembly without affecting other **Fluent** assemblies.\n\nSimilarly, `Fluent.get_locale/0` gets the locale for all assemblies in the current process. `Fluent.get_locale/1` gets the locale of a specific assembly for the current process. Check their documentation for more information.\n\nLocales are expressed as strings (like \"en\" or \"fr\"); they can be arbitrary strings as long as they match a directory name. As mentioned above, the locale is stored per-process (in the process dictionary): this means that the locale must be set in every new process in order to have the right locale available for that process. Pay attention to this behaviour, since not setting the locale will not result in any errors when `Fluent.get_locale/0` or `Fluent.get_locale/1` are called; the default locale will be returned instead.\n\nTo decide which locale to use, each gettext-related function in a given assembly follows these steps:\n\n* if there is a assembly-specific locale for the given assembly for this process (see `Fluent.put_locale/2`), \n  use that, *otherwise*\n* if there is a global locale for this process (see `Fluent.put_locale/1`), \n  use that, *otherwise*\n* if there is a assembly's specific default locale in the configuration for that assembly's `:otp_app`\n  (see the [**Default locale**](#default-locale) section below), use that, *otherwise*\n* use the default global **Fluent** locale (see the [**Default locale**](#default-locale) section below)\n\n\n#","ref":"readme.html#locale","title":"Locale - libfluent","type":"extras"},{"doc":"The global **Fluent** default locale can be configured through the `:default_locale` key of the `:libfluent` application:\n\n```elixir\nconfig :libfluent, :default_locale, \"fr\"\n```\n\nBy default the global locale is \"en\".\n\nIf for some reason an assembly requires with a different `:default_locale` than all other assemblies, you can set the `:default_locale` inside the assembly configuration, but this approach is generally discouraged as it makes it hard to track which locale each assembly is using:\n\n```elixir\nconfig :my_app, MyApp.Fluent, default_locale: \"fr\"\n```","ref":"readme.html#default-locale","title":"Default locale - libfluent","type":"extras"},{"doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `fluent` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:libfluent, \"~> 0.2.2\"}\n  ]\nend\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at [https://hexdocs.pm/libfluent](https://hexdocs.pm/libfluent).","ref":"readme.html#installation","title":"Installation - libfluent","type":"extras"}]}